
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>开发一个Linux调试器（一）：准备环境 / iVAN</title>

    <meta name="description" content="开发一个Linux调试器（一）：准备环境 任何写过比 hello world 复杂一些的程序的人都应该使用过调试器(如果你还没有,那就停下手头的工作先学习一下吧).但是,尽管这些工具已经得到了广泛的使用,却并没有太多的资源告诉你它们的工作原理以及如何开发,尤其是和其它那些比如编译器等工具链技术相比而言. 此处有一些其它的资源可以参考: http://eli.thegreenplace.net/2011/01/23/how-debuggers-work-part-1 https://t-a-w.blogspot.co.uk/2007/03">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">开发一个Linux调试器（一）：准备环境</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="http://s2.51cto.com/wyfs02/M00/99/AD/wKioL1lLMGywD6hJAAOEf_exdzc219.jpg-wh_651x-s_2655402431.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczIuNTFjdG8uY29tL3d5ZnMwMi9NMDAvOTkvQUQvd0tpb0wxbExNR3l3RDZoSkFBT0VmX2V4ZHpjMjE5LmpwZy13aF82NTF4LXNfMjY1NTQwMjQzMS5qcGc=.jpg"></a></p>
<p>任何写过比 hello world 复杂一些的程序的人都应该使用过调试器(如果你还没有，那就停下手头的工作先学习一下吧)。但是，尽管这些工具已经得到了广泛的使用，却并没有太多的资源告诉你它们的工作原理以及如何开发，尤其是和其它那些比如编译器等工具链技术相比而言。</p>
<p>此处有一些其它的资源可以参考：</p>
<ul>
<li>http://eli.thegreenplace.net/2011/01/23/how-debuggers-work-part-1</li>
<li>https://t-a-w.blogspot.co.uk/2007/03/how-to-code-debuggers.html</li>
<li>https://www.codeproject.com/Articles/43682/Writing-a-basic-Windows-debugger</li>
<li>http://system.joekain.com/debugger/</li>
</ul>
<p>我们将会支持以下功能：</p>
<ul>
<li>启动、暂停、继续执行</li>
<li>在不同地方设置断点
<ul>
<li>内存地址</li>
<li>源代码行</li>
<li>函数入口</li>
</ul>
</li>
<li>读写寄存器和内存</li>
<li>单步执行
<ul>
<li>指令</li>
<li>进入函数</li>
<li>跳出函数</li>
<li>跳过函数</li>
</ul>
</li>
<li>打印当前代码地址</li>
<li>打印函数调用栈</li>
<li>打印简单变量的值</li>
</ul>
<p>在最后一部分，我还会大概介绍如何给你的调试器添加下面的功能：</p>
<ul>
<li>远程调试</li>
<li>共享库和动态库支持</li>
<li>表达式计算</li>
<li>多线程调试支持</li>
</ul>
<p>在本项目中我会将重点放在 C 和 C++，但对于那些将源码编译为机器码并输出标准 DWARE 调试信息的语言也应该能起作用(如果你还不知道这些东西是什么，别担心，马上就会介绍到啦)。另外，我只关注如何将程序运行起来并在大部分情况下能正常工作，为了简便，会避开类似健壮错误处理方面的东西。</p>
<p><strong>系列文章索引</strong></p>
<p>随着后面文章的发布，这些链接会逐渐生效。</p>
<ol>
<li>准备环境</li>
<li>断点</li>
<li>寄存器和内存</li>
<li>Elves 和 dwarves</li>
<li>源码和信号</li>
<li>源码层逐步执行</li>
<li>源码层断点</li>
<li>调用栈</li>
<li>读取变量</li>
<li>之后步骤</li>
</ol>
<p>LCTT 译注：ELF —— 可执行文件格式(Executable and Linkable Format);DWARF(一种广泛使用的调试数据格式，参考 WIKI)。</p>
<p><strong>准备环境</strong></p>
<p>在我们正式开始之前，我们首先要设置环境。在这篇文章中我会依赖两个工具：Linenoise 用于处理命令行输入，libelfin 用于解析调试信息。你也可以使用更传统的 libdwarf 而不是 libelfin，但是界面没有那么友好，另外 libelfin 还提供了基本完整的 DWARF 表达式求值器，当你想读取变量的值时这能帮你节省很多时间。确认你使用的是 libelfin 我的 fbreg 分支，因为它提供 x86 上读取变量的额外支持。</p>
<p>一旦你在系统上安装或者使用你喜欢的编译系统编译好了这些依赖工具，就可以开始啦。我在 CMake 文件中把它们设置为和我其余的代码一起编译。</p>
<p><strong>启动可执行程序</strong></p>
<p>在真正调试任何程序之前，我们需要启动被调试的程序。我们会使用经典的 fork/exec 模式。</p>
<pre>
</pre>
<ol>
<li>int main(int argc, char* argv[]) { </li>
<li>    if (argc &lt; 2) { </li>
<li>        std::cerr &lt;&lt; "Program name not specified"; </li>
<li>        return -1; </li>
<li>    } </li>
<li>    auto prog = argv[1]; </li>
<li>    auto pid = fork(); </li>
<li>    if (pid == 0) { </li>
<li>        //we're in the child process </li>
<li>        //execute debugee </li>
<li>    } </li>
<li>    else if (pid &gt;= 1)  { </li>
<li>        //we're in the parent process </li>
<li>        //execute debugger </li>
<li>    } </li>
</ol>
<p>我们调用 fork 把我们的程序分成两个进程。如果我们是在子进程，fork 返回 0，如果我们是在父进程，它会返回子进程的进程 ID。</p>
<p>如果我们是在子进程，我们要用希望调试的程序替换正在执行的程序。</p>
<pre>
</pre>
<ol>
<li>ptrace(PTRACE_TRACEME, 0, nullptr, nullptr); </li>
<li>execl(prog.c_str(), prog.c_str(), nullptr); </li>
</ol>
<p>这里我们第一次遇到了 ptrace，它会在我们编写调试器的时候经常遇到。ptrace 通过读取寄存器、内存、逐步调试等让我们观察和控制另一个进程的执行。其 API 非常简单;你需要给这个简单函数提供一个枚举值指定你想要进行的操作，然后是一些取决于你所提供的值可能会被使用也可能会被忽略的参数。函数原型看起来类似：</p>
<pre>
</pre>
<ol>
<li>long ptrace(enum __ptrace_request request, pid_t pid, void *addr, void *data); </li>
</ol>
<p>request 是我们想对被跟踪进程进行的操作;pid 是被跟踪进程的进程 ID;addr 是一个内存地址，用于在一些调用中指定被跟踪程序的地址;data 是 request 相应的资源。返回值通常是一些错误信息，因此在你实际的代码中你也许应该检查返回值;为了简洁我这里就省略了。你可以查看 man 手册获取更多(关于 ptrace)的信息。</p>
<p>上面代码中我们发送的请求 PTRACE_TRACEME 表示这个进程应该允许父进程跟踪它。所有其它参数都会被忽略，因为 API 设计并不是很重要，哈哈。</p>
<p>下一步，我们会调用 execl，这是很多诸多的 exec 函数格式之一。我们执行指定的程序，通过命令行参数传递它的名称，然后用一个 nullptr 终止列表。如果你愿意，你还可以传递其它执行你的程序所需的参数。</p>
<p>在完成这些后，我们就会和子进程一起结束;在我们结束它之前它会一直执行。</p>
<p><strong>添加调试循环</strong></p>
<p>现在我们已经启动了子进程，我们想要能够和它进行交互。为此，我们会创建一个 debugger 类，循环监听用户输入，然后在我们父进程的 main 函数中启动它。</p>
<pre>
</pre>
<ol>
<li>else if (pid &gt;= 1)  { </li>
<li>    //parent </li>
<li>    debugger dbg{prog, pid}; </li>
<li>    dbg.run(); </li>
<li>}  </li>
</ol>
<pre>
</pre>
<ol>
<li>class debugger { </li>
<li>public: </li>
<li>    debugger (std::string prog_name, pid_t pid) </li>
<li>        : m_prog_name{std::move(prog_name)}, m_pid{pid} {} </li>
<li>    void run(); </li>
<li>private: </li>
<li>    std::string m_prog_name; </li>
<li>    pid_t m_pid; </li>
<li>}; </li>
</ol>
<p>在 run 函数中，我们需要等待，直到子进程完成启动，然后一直从 linenoise 获取输入直到收到 EOF(CTRL+D)。</p>
<pre>
</pre>
<ol>
<li>void debugger::run() { </li>
<li>    int wait_status; </li>
<li>    auto options = 0; </li>
<li>    waitpid(m_pid, &amp;wait_status, options); </li>
<li>    char* line = nullptr; </li>
<li>    while((line = linenoise("minidbg&gt; ")) != nullptr) { </li>
<li>        handle_command(line); </li>
<li>        linenoiseHistoryAdd(line); </li>
<li>        linenoiseFree(line); </li>
<li>    } </li>
<li>} </li>
</ol>
<p>当被跟踪的进程启动时，会发送一个 SIGTRAP 信号给它，这是一个跟踪或者断点中断。我们可以使用 waitpid 函数等待这个信号发送。</p>
<p>当我们知道进程可以被调试之后，我们监听用户输入。linenoise 函数它自己会用一个窗口显示和处理用户输入。这意味着我们不需要做太多的工作就会有一个支持历史记录和导航命令的命令行。当我们获取到输入时，我们把命令发给我们写的小程序 handle_command，然后我们把这个命令添加到 linenoise 历史并释放资源。</p>
<p><strong>处理输入</strong></p>
<p>我们的命令类似 gdb 以及 lldb 的格式。要继续执行程序，用户需要输入 continue 或 cont 甚至只需 c。如果他们想在一个地址中设置断点，他们会输入 break 0xDEADBEEF，其中 0xDEADBEEF 就是所需地址的 16 进制格式。让我们来增加对这些命令的支持吧。</p>
<pre>
</pre>
<ol>
<li>void debugger::handle_command(const std::string&amp; line) { </li>
<li>    auto args = split(line,' '); </li>
<li>    auto command = args[0]; </li>
<li>    if (is_prefix(command, "continue")) { </li>
<li>        continue_execution(); </li>
<li>    } </li>
<li>    else { </li>
<li>        std::cerr &lt;&lt; "Unknown command\n"; </li>
<li>    } </li>
<li>} </li>
</ol>
<p>split 和 is_prefix 是一对有用的小程序：</p>
<pre>
</pre>
<ol>
<li>std::vector&lt;std::string&gt; split(const std::string &amp;s, char delimiter) { </li>
<li>    std::vector&lt;std::string&gt; out{}; </li>
<li>    std::stringstream ss {s}; </li>
<li>    std::string item; </li>
<li>    while (std::getline(ss,item,delimiter)) { </li>
<li>        out.push_back(item); </li>
<li>    } </li>
<li>    return out; </li>
<li>} </li>
<li>bool is_prefix(const std::string&amp; s, const std::string&amp; of) { </li>
<li>    if (s.size() &gt; of.size()) return false; </li>
<li>    return std::equal(s.begin(), s.end(), of.begin()); </li>
<li>} </li>
</ol>
<p>我们会把 continue_execution 函数添加到 debuger 类。</p>
<pre>
</pre>
<ol>
<li>void debugger::continue_execution() { </li>
<li>    ptrace(PTRACE_CONT, m_pid, nullptr, nullptr); </li>
<li>    int wait_status; </li>
<li>    auto options = 0; </li>
<li>    waitpid(m_pid, &amp;wait_status, options); </li>
<li>} </li>
</ol>
<p>现在我们的 continue_execution 函数会用 ptrace 告诉进程继续执行，然后用 waitpid 等待直到收到信号。</p>
<p><strong>总结</strong></p>
<p>现在你应该编译一些 C 或者 C++ 程序，然后用你的调试器运行它们，看它是否能在函数入口暂停、从调试器中继续执行。在下一篇文章中，我们会学习如何让我们的调试器设置断点。如果你遇到了任何问题，在下面的评论框中告诉我吧!</p>
<p>你可以在这里找到该项目的代码。</p>
<p>作者：Simon Brand</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 01:31:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>, <a href="https://www.iamivan.net/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>开发一个Linux调试器（一）：准备环境的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqAROKM.html" rel="bookmark">开发一个Linux调试器（十）：高级主题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们终于来到这个系列的最后一篇文章!这一次,我将对调试中的一些更高级的概念进行高层的概述:远程调试.共享库支持.表达式计算和多线程支持.这些想法实现起来比较复杂,所以我不会详细说明如何做,但是如果你有问题的话,我很乐意回答有关这些概念的问题. 系列索引 准备环境 断点 寄存器和内存 ELF 和 DWARF 源码和信号 源码级逐步执行 源码级断点 堆栈展开 处理变量 高级话题 远程调试 远程调试对于嵌入式系统或对不同环境进行调试非常有用.它还在高级调试器操作和与操作系统和硬件的交互之间设置了一个很			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bamnBNb.html" rel="bookmark">开发一个Linux调试器（二）：断点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在该系列的第一部分,我们写了一个小的进程启动器,作为我们调试器的基础.在这篇博客中,我们会学习在 x86 Linux 上断点是如何工作的,以及如何给我们工具添加设置断点的能力. 系列文章索引 随着后面文章的发布,这些链接会逐渐生效. 准备环境 断点 寄存器和内存 Elves 和 dwarves 源码和信号 源码层逐步执行 源码层断点 调用栈 读取变量 10.之后步骤 断点是如何形成的? 有两种类型的断点:硬件和软件.硬件断点通常涉及到设置与体系结构相关的寄存器来为你产生断点,而软件断点则涉及到修			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvn5m5M.html" rel="bookmark">开发一个Linux调试器（五）：源码和信号</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一部分我们学习了关于 DWARF 的信息,以及它如何被用于读取变量和将被执行的机器码与我们的高级语言的源码联系起来.在这一部分,我们将进入实践,实现一些我们调试器后面会使用的 DWARF 原语.我们也会利用这个机会,使我们的调试器可以在命中一个断点时打印出当前的源码上下文. 系列文章索引 随着后面文章的发布,这些链接会逐渐生效. 准备环境 断点 寄存器和内存 Elves 和 dwarves 源码和信号 源码级逐步执行 源码级断点 调用栈展开 读取变量 下一步 设置我们的 DWARF 解析器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZBPlqz.html" rel="bookmark">开发一个Linux调试器（四）：Elves和dwarves</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				到目前为止,你已经偶尔听到了关于 dwarves.调试信息.一种无需解析就可以理解源码方式.今天我们会详细介绍源码级的调试信息,作为本指南后面部分使用它的准备. 系列文章索引 随着后面文章的发布,这些链接会逐渐生效. 准备环境 断点 寄存器和内存 Elves 和 dwarves 源码和信号 源码级逐步执行 源码级断点 调用栈展开 读取变量 下一步 ELF 和 DWARF 简介 ELF 和 DWARF 可能是两个你没有听说过,但可能大部分时间都在使用的组件.ELF(Executable and L			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z429Z9M.html" rel="bookmark">开发一个Linux调试器（八）：堆栈展开</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有时你需要知道的最重要的信息是什么,你当前的程序状态是如何到达那里的.有一个 backtrace 命令,它给你提供了程序当前的函数调用链.这篇文章将向你展示如何在 x86_64 上实现堆栈展开以生成这样的回溯. 系列索引 这些链接将会随着其他帖子的发布而上线. 准备环境 断点 寄存器和内存 ELF 和 DWARF 源码和信号 源码级逐步执行 源码级断点 堆栈展开 读取变量 之后步骤 用下面的程序作为例子: void a() {      //stopped here  }  void b() {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8kLYlM.html" rel="bookmark">开发一个Linux调试器（三）：寄存器和内存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇博文中我们给调试器添加了一个简单的地址断点.这次,我们将添加读写寄存器和内存的功能,这将使我们能够使用我们的程序计数器.观察状态和改变程序的行为. 系列文章索引 随着后面文章的发布,这些链接会逐渐生效. 准备环境 断点 寄存器和内存 Elves 和 dwarves 源码和信号 源码级逐步执行 源码级断点 调用栈展开 读取变量 下一步 注册我们的寄存器 在我们真正读取任何寄存器之前,我们需要告诉调试器一些关于我们的目标平台的信息,这里是 x8664 平台.除了多组通用和专用目的寄存器,x86			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXdn5vp.html" rel="bookmark">开发一个Linux调试器（六）：源码级逐步执行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前几篇博文中我们学习了 DWARF 信息以及它如何使我们将机器码和上层源码联系起来.这一次我们通过为我们的调试器添加源码级逐步调试将该知识应用于实际. 系列文章索引 随着后面文章的发布,这些链接会逐渐生效. 准备环境 断点 寄存器和内存 Elves 和 dwarves 源码和信号 源码级逐步执行 源码级断点 调用栈展开 读取变量 下一步 揭秘指令级逐步执行 我们正在超越了自我.首先让我们通过用户接口揭秘指令级单步执行.我决定将它切分为能被其它部分代码利用的 single_step_instru			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bodjPEM.html" rel="bookmark">《嵌入式 Linux C 语言应用程序设计（修订版）》&mdash;&mdash;2&period;4　嵌入式Linux调试器GDB的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 嵌入式Linux调试器GDB的使用 在程序编译通过生成可执行文件之后,就进入了程序的调试环节.调试一直来是程序开发中的重中之重,如何使程序员能够迅速找到错误的原因是一款调试器的目标. GDB是GNU开源组织发布的一个强大的Linux下的程序调试工具,它是一种强大的命令行调试工具. 一个出色的调试器需要有以下几项功能. 能够运行程序,设置所有能影响程序运行的参数. 能够让程序让指定的条件下停止. 能够在程序停止时检查所有参数的情况. 能够根据指定条件改变程序的运行. 2.4.1 GDB使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Zvdmz.html" rel="bookmark">《嵌入式 Linux C 语言应用程序设计（修订版）》一2&period;4　嵌入式Linux调试器GDB的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.4 嵌入式Linux调试器GDB的使用 嵌入式 Linux C 语言应用程序设计(修订版)在程序编译通过生成可执行文件之后,就进入了程序的调试环节.调试一直来是程序开发中的重中之重,如何使程序员能够迅速找到错误的原因是一款调试器的目标. GDB是GNU开源组织发布的一个强大的Linux下的程序调试工具,它是一种强大的命令行调试工具. 一个出色的调试器需要有以下几项功能. 能够运行程序,设置所有能影响程序运行的参数.能够让程序让指定的条件下停止.能够在程序停止时检查所有参数的情况.能够根据指定			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyQ95M.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;麻刚沙&rdquo;做资源，中国式SEO不怕悬</a>
					<div>
						中午吃完饭后,同事们都出去了,一个人在办公室看热点新闻事件,一则用&quot;麻刚沙&quot;来盖楼的文章让小弟颇有感概,回想起上午和老板一起聊聊的网站优化话题,于是便有了这篇&quot;麻刚沙&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv0oAz.html" rel="bookmark" class="title">深入剖析C&num;继承机制1</a>
					<div>
						继承 一. 继承基础知识 为了提高软件模块的可复用性和可扩充性,以便提高软件的开发效率,我们总是希望能够利用前人或自己以前的开发成果,同时又希望在自己的开发过程中能够有足够的灵活性,不拘泥于复用的模块 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1qojM.html" rel="bookmark" class="title">使用WMIC从命令行对Windows的全面管理</a>
					<div>
						从Windows 2000开始,WMI(Windows 管理规范)就是Windows系统管理的重要组成部分.WMIC是Windows Management Instrumentation Comman ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAarX2M.html" rel="bookmark" class="title">在T-SQL中用队列来遍历层级数据</a>
					<div>
						前几天看了&lt;The Guru's Guide To Transact SQL&gt;(中文翻译是Transact-SQL 权威指南),里面介绍的一个查询 是关于层级结构的,处理的方式本质就是队列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo69ajz.html" rel="bookmark" class="title">j2me游戏中使用记录管理系统保存和读取最高纪录</a>
					<div>
						纪录管理系统(Record Management System ,简称RMS).他能使你能够在手机设备的内存中持久地存储数据. 一.记录管理系统概览 记录管理系统简单的说就是一个小型的数据库.具有典型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRZkVz.html" rel="bookmark" class="title">TP-LINK WR700N路由器怎么设置</a>
					<div>
						  TP-LINK WR700N路由器设置方法 型号为V1.V2的管理路由器的地址为:192.168.1.253,将IP地址输入浏览器的地址栏,按回车键打开设置界面. 型号为V3的管理路由器的地址为: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0P1QPM.html" rel="bookmark" class="title">PS关于如何调出日系青色胶片质感的照片？</a>
					<div>
						  关于如何调出日系青色胶片质感的照片?&quot;刚好在网上看到这个教程非常的实用,分享给大家学习,效果非常的不错,分析也很到位全面,原图也提供 分类: PS调色教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL4yOb.html" rel="bookmark" class="title">EXCEL统计函数--COUNTBLANK</a>
					<div>
						COUNTBLANK与COUNT和COUNTA一样,是EXCEL2010中使用率较高的统计函数.COUNTBLANK函数是用来统计EXCEL2010工作表中空白单元格个数的.空白单元格的意思是没有输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wQKJp.html" rel="bookmark" class="title">电子商务网站设计分析系列之一：首页导航</a>
					<div>
						伴随着互联网的成长,通过电子商务网站实现商品交易越来越频繁,而访客在面对越来越庞大的信息量时会感到迷茫,因此,优秀的导航设计能够提高网站的易用性,对实现电子商务网站的高效运作具有实际意义.另外,电子商 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOamR8M.html" rel="bookmark" class="title">如何设置共享打印机教程</a>
					<div>
						共享打印前请确认,共享者的电脑和使用者的电脑在同一个局域网内,同时该局域网是畅通的. 第一步,共享打印机. 1.首先,确认与共享打印机相连的处于开机状态,而且已经安装过打印机驱动程序,并且可实现正常打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8gKGb.html" rel="bookmark" class="title">windows8&period;1扩展分区的方法</a>
					<div>
						  单击&quot;开始&quot;菜单,从附件中找到&quot;命令提示符&quot;,右击选择&quot;以管理员身份运行&quot;打开命令提示符窗口,输入&quot;diskpart&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3P2BM.html" rel="bookmark" class="title">45个设计师需要熟记的PS快捷键</a>
					<div>
						  图层 填充图层 MAC: Alt+Backspace (前景) or Cmd+Backspace (背景) WINDOWS: Alt+Delete (前景) or Ctrl+Delete (背景) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaLvAz.html" rel="bookmark" class="title">酷狗音乐怎么收藏歌曲</a>
					<div>
						  1.打开酷狗,找到&quot;网络收藏&quot;模块并进入. 2.大家请先登陆自己的酷狗账号,这样收藏的歌曲就可以云同步咯. 列表没了&quot;&gt; 3.成功登陆以后我们可以新建一个网络收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwx6Bb.html" rel="bookmark" class="title">我们要在任何可能的地方测试XSS漏洞</a>
					<div>
						在这篇文章中,我准备跟大家讨论几种不同的场景,在这些场景中,不同的服务都会收集各种各样的数据,但它们又无法正确地去处理这些数据.在某些情况下,数据采用的是安全格式存储和传输的,但是由于数据的解析操作以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR7Ydz.html" rel="bookmark" class="title">解析txt文本问题。。。。</a>
					<div>
						问题描述 txt文本文件里之有数字1和0但是有很多.首先一个一个的读取存入数组,然后判断如果是1就动态生成一个button是0就不生成,这个要怎么些呢. 解决方案 解决方案二:逻辑你自己已经分析的很清 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm54vz.html" rel="bookmark" class="title">独家获悉：苹果和微软在华哄抢PostgreSQL高端人才</a>
					<div>
						作为全球知名的开源数据库,PostgreSQL以优雅的代码和文档.稳定的性能.极高的可靠性.以及强大的功能和SQL标准兼容性闻名,在企业核心库方面也有不俗表现. 然而,伴随PostgreSQL的走强, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQAVLp.html" rel="bookmark" class="title">用img标签实现数据提交</a>
					<div>
						 其实不一定要使用script标签,用img标签也可以实现. (如果远端要回传大量数据,而不是bool类型的标志,则需要使用script标签). 把下面代码保存到本地html,用户名:&quot;de ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAmreM.html" rel="bookmark" class="title">网站推荐系统&OpenCurlyDoubleQuote;猜你喜欢&rdquo;是怎么猜中你心思的？</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 现在人们上网购物都习惯了系统给出的&quot;猜你(还会)喜欢&quot;,有时候它好像比你自己都还要了解你.推荐系统究竟是怎样&quot;猜&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7Z5oz.html" rel="bookmark" class="title">监狱 5人小组徒手造电脑，入侵监狱网络居然不是为了越狱</a>
					<div>
						  最近,雷锋网(公众号:雷锋网)宅客频道的大姐姐有点小开心,当年被同学安利的第一部美剧&lt;越狱&gt;居然在男主都死透透几年后,开始&quot;起死回生&quot;,播第五季了! 然后,大姐姐屁 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXwPxz.html" rel="bookmark" class="title">招聘GIS应用开发工程师（广州）</a>
					<div>
						问题描述 广州市澄浩信息科技有限公司本公司是一家集&quot;研发,生产,销售&quot;为一体的高科技企业,主要从事GPS导航仪.GPS行车警示器等高端电子产品研究.开发.生产及信息数据库的开发等业 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKv3oz.html" rel="bookmark" class="title">ios-iOS 推送配置问题，要不要交99美元</a>
					<div>
						问题描述 iOS 推送配置问题,要不要交99美元 这两张图片是网上给出的iOS推送证书.id等配置的页面,可是我的是图下面这样的,难道是因为美脚费用吗?如果不用交费那改如何实现 解决方案 是的,让你& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKGLJp.html" rel="bookmark" class="title">网易彩票借力大数据 豪送2亿助力彩民&OpenCurlyDoubleQuote;易定赢&rdquo;</a>
					<div>
						面对发展迅猛的http://www.aliyun.com/zixun/aggregation/1737.html&quot;&gt;互联网彩票市场,你还习惯用纸笔统计数据吗?你还会211.html&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqVxyb.html" rel="bookmark" class="title">Haskell：什么时候该注释，什么时候不该注释</a>
					<div>
						大家都知道,写程序时应该让程序易读易懂,而添加注释是让你的程序实现这个目标的好方法.然而,对于一个程序,并不是你添加了足够多的注释,它就能 变得的易懂易读.事实上,第一要务是你的程序要写的干净整洁,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXYdBb.html" rel="bookmark" class="title">百度 定位-百度sdk定位如何设置超时</a>
					<div>
						问题描述 百度sdk定位如何设置超时 Android项目中用到了百度sdk定位,手机无法访问百度服务器的时候,定位的回调函数要30秒才能调用,我能设置5秒或者10秒吗? 求大神解答					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2Wjwz.html" rel="bookmark" class="title">传微软新版搜索&OpenCurlyDoubleQuote;kumo&rdquo;测试完毕 下周将展示</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 5月20日消息,据媒体报道,本周二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn86XKb.html" rel="bookmark" class="title">C&plus;&plus;编程中队内联函数的理解和使用&lowbar;C 语言</a>
					<div>
						函数调用过程c++经过编译生成可执行程序文件exe,存放在外存储器中.程序启动,系统从外存储器中将可执行文件装载到内存中,从入口地址(main函数起始处)开始执行.程序执行中遇到了对其他函数的调用,就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNv8vNM.html" rel="bookmark" class="title">js实现带圆角的两级导航菜单效果代码&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了js实现带圆角的两级导航菜单效果代码.分享给大家供大家参考.具体如下: 这是一款使用JS做的圆角菜单,支持两级菜单显示,本人比较喜欢的风格,修改使用方便,新手也能上手快.使用有几张圆角图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7woeM.html" rel="bookmark" class="title">Android RecyclerView滑动删除和拖动排序&lowbar;Android</a>
					<div>
						本篇是接着上面三篇之后的一个对RecyclerView的介绍,这里多说两句,如果你还在使用ListView的话,可以放弃掉ListView了.RecyclerView自动帮我们缓存Item视图(Vie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVl5az.html" rel="bookmark" class="title">Mac环境下php操作mysql数据库的方法分享&lowbar;php技巧</a>
					<div>
						Mac本地环境搭建 在Mac系统,我们可以使用MAMP Pro 软件来搭建本地服务器.安装好这款软件,网站的目录在 /Applications/MAMP/htdocs 文件夹里,只需将文件放入该文件夹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7oEDb.html" rel="bookmark" class="title">javascript Window 对象详解介绍</a>
					<div>
						Window 对象 Window 对象表示浏览器中打开的窗口,如果文档包含框架(frame 或 iframe 标签),浏览器会为 HTML 文档创建一个 window 对象,并为每个框架创建一个额外的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
